﻿using System;
using System.Text;
using System.Diagnostics;
using System.Net.Http;
using System.Net.Http.Headers;
using System.IO;

namespace PositionExtraction
{
    class PositionExtraction
    {
        private static string key = "your_api_key";
        private static string url = "https://sandbox.esignlive.com/api";

        public void Execute()
        {
            string jsonString = "{\"roles\":[{\"id\":\"Signer1\",\"type\":\"SIGNER\",\"signers\":[{\"firstName\":\"John\",\"lastName\":\"Smith\",\"email\":\"john.smith@mailinator.com\"}],\"name\":\"Signer1\"}],\"documents\":[{\"approvals\":[{\"fields\":[{\"type\":\"INPUT\",\"extract\":true,\"subtype\":\"LABEL\",\"name\":\"name1\",\"binding\":\"{signer.name}\"},{\"type\":\"INPUT\",\"extract\":true,\"subtype\":\"TEXTFIELD\",\"name\":\"age1\"},{\"type\":\"INPUT\",\"extract\":true,\"subtype\":\"TEXTFIELD\",\"name\":\"address1\"},{\"type\":\"INPUT\",\"extract\":true,\"subtype\":\"TEXTFIELD\",\"name\":\"zip1\"},{\"type\":\"INPUT\",\"extract\":true,\"subtype\":\"TEXTFIELD\",\"name\":\"city1\"},{\"type\":\"SIGNATURE\",\"extract\":true,\"subtype\":\"FULLNAME\",\"name\":\"sig1\"}],\"role\":\"Signer1\"}],\"extract\":true,\"name\":\"Sample Contract\"}],\"name\":\"Field Position Extraction Example\",\"type\":\"PACKAGE\",\"language\":\"en\",\"autoComplete\":true,\"status\":\"SENT\"}";

            StringContent jsonContent = new StringContent(jsonString, Encoding.UTF8, "application/json");

            byte[] fileByteArray = File.ReadAllBytes(@"C:\Users\...\PositionExtractionSamplePDF.pdf");
            ByteArrayContent content = new ByteArrayContent(fileByteArray);

            content.Headers.ContentDisposition = new ContentDispositionHeaderValue("form-data");
            content.Headers.ContentDisposition.Name = "\"file\"";
            content.Headers.ContentDisposition.FileName = "\"PositionExtractionSamplePDF.pdf\"";
            content.Headers.ContentType = new MediaTypeHeaderValue("application/pdf");

            MultipartFormDataContent form = new MultipartFormDataContent();
            form.Add(content, "\"file\"", "\"PositionExtractionSamplePDF.pdf\"");
            form.Add(jsonContent, "\"payload\"");

            HttpClient myClient = new HttpClient();
            myClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", key);
            myClient.DefaultRequestHeaders.Add("Accept", "application/json");

            var response = myClient.PostAsync(new Uri(url) + "/packages/", form).Result;
            Debug.WriteLine(response.Content.ReadAsStringAsync().Result);

        }
    }
}
